#property indicator_chart_window
#property indicator_buffers 2

#property indicator_color1 ForestGreen
#property indicator_color2 Red

#property indicator_width1 2
#property indicator_width2 2


extern double stopl=30;
extern int    bars=1000;

//---- buffers
double CA1[];
double CA2[];
double LineRed[];
double LineGreen[];

double v1, v2, v3, v4;

//+------------------------------------------------------------------+
//| Custom indicator initialization function |
//+------------------------------------------------------------------+
int init()
{
//---- indicators
IndicatorBuffers(4);
SetIndexStyle(0,DRAW_LINE);
SetIndexStyle(1,DRAW_LINE);

SetIndexBuffer(0,LineGreen);
SetIndexBuffer(1,LineRed);
SetIndexBuffer(2,CA1);
SetIndexBuffer(3,CA2);

SetIndexArrow( 0, 251);
SetIndexArrow( 1, 251);

//----
return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function |
//+------------------------------------------------------------------+
int start() {


    int counted_bars = IndicatorCounted();
    if (counted_bars < 0) return(-1);
    if (counted_bars > 0) counted_bars--;

    int i, limit;

    limit=Bars - counted_bars-1;

    limit = bars;
    v1 = 0;
    v2 = 0;
    v3 = 0;
    v4 = 0;

    for(i=limit;i>=0;i--) 
    {
        if ( Close[i] > Open[i] ) ///bar vverh
        {
            v3=v1;
            v1=Open[i] - stopl*Point;
            if( (v1 < v3) && (Open[i] > v3) )
            {v1=v3;} 
        }

        else 
        {
         if ( Close[i] < Open[i] ) ///bar vniz
         {
            v4=v2;
            v2=stopl*Point + Open[i];
            if( (v4 < v2) && (Open[i] < v4) )
            {v2=v4;} 
         }
         else 
         { //   if ( Close[i] == Open[i] )
            v1=CA1[i+1]; v2=CA2[i+1];
         }
        }
  

        CA1[i]=v1;
        CA2[i]=v2;
    }
    for(i=limit;i>=0;i--) 
    {
    LineGreen[i-1]=CA1[i];
    LineRed[i-1]=CA2[i];
    }
    return(0);
}